## cain 1.9

=== Makefile ===
# -*- Makefile -*-

# By default make the solvers.
default:
	$(MAKE) -C src/solvers $(MAKEFLAGS) $(MAKECMDGOALS)

again: 

clean: 
	$(RM) *~ *.pyc */*.pyc

distclean: clean
	rm -rf Cain
	rm -f Cain.app/Contents/Resources/Cain.py
	rm -rf Cain.app/Contents/Resources/gui
	rm -rf Cain.app/Contents/Resources/fio
	rm -rf Cain.app/Contents/Resources/simulation
	rm -rf Cain.app/Contents/Resources/solvers
	rm -rf Cain.app/Contents/Resources/state

test:
	nosetests --with-doctest -v simulation state

# Platform-independent.
pi:
	rm -rf Cain
	mkdir Cain
	mkdir Cain/gui
	mkdir Cain/fio
	mkdir Cain/simulation
	mkdir Cain/state
	cp Cain.py resourcePath.py Makefile Cain
	cp -R gui/*.py gui/*.html gui/*.png gui/icons gui/figures Cain/gui
	cp fio/*.py Cain/fio
	cp simulation/*.py Cain/simulation
	cp state/*.py Cain/state
	cp -R examples help src solvers Cain

# Put the python framework in the Mac OS X bundle.
framework:
	rm -rf Cain.app/Contents/Frameworks/Python.framework
	cp -R /Library/Frameworks/Python.framework Cain.app/Contents/Frameworks
	rm -rf Cain.app/Contents/Frameworks/Python.framework/Versions/2.6

# Mac OS X.
# First compile the executables with SCons and then rm *.o.
bundle:
	rm -rf Cain.app/Contents/Resources/Cain.py \
               Cain.app/Contents/Resources/gui \
               Cain.app/Contents/Resources/fio \
               Cain.app/Contents/Resources/simulation \
               Cain.app/Contents/Resources/src \
               Cain.app/Contents/Resources/solvers \
               Cain.app/Contents/Resources/state 
	mkdir Cain.app/Contents/Resources/gui
	mkdir Cain.app/Contents/Resources/fio
	mkdir Cain.app/Contents/Resources/simulation
	mkdir Cain.app/Contents/Resources/state
	cp Cain.py gui/icons/Cain.icns Cain.app/Contents/Resources
	cp -R gui/*.py gui/*.html gui/*.png gui/icons gui/figures Cain.app/Contents/Resources/gui
	cp fio/*.py Cain.app/Contents/Resources/fio
	cp simulation/*.py Cain.app/Contents/Resources/simulation
	cp -R examples help src solvers Cain.app/Contents/Resources
	cp state/*.py Cain.app/Contents/Resources/state

# MS Windows.
# First compile the executables and rm *.obj
win:
#	cp /c/Program\ Files/Microsoft\ Visual\ Studio\ 9.0/VC/redist/x86/Microsoft.VC90.CRT/msvcp90.dll .
	rm -rf build dist
	python setupWin.py py2exe
	cp -R gui/help.html gui/splash.png gui/icons gui/figures dist/gui
	cp -R examples help src solvers dist
	cp msvcp90.dll dist

# Old info for Python 2.5:
# Copy C:\Python25\Lib\site-src\wx\msvcp71.dll to dist
# or
# copy C:\Windows/System32/msvcp71.dll to dist
# after running "make win".

=== src/solvers/Makefile ===
# -*- Makefile -*-

# Add the location of the source code.
CXXINCLUDE += -I..

#include Makefile.compilers
CXX = g++
CXXFLAGS += $(CXXINCLUDE)
ifdef DEBUG
CXXFLAGS += -g -DDEBUG_stlib
else
# Optimization
# Improves performance by 3 or 4%. Should I use it?
#CXXFLAGS += -ffast-math
# Increase the inline limit from 600 to 6000.
CXXFLAGS += -finline-limit=6000
CXXFLAGS += -O3 -funroll-loops -Wstrict-aliasing
endif
# Language.
CXXFLAGS += -ansi -Wall
# Commented out for Eigen.
#CXXFLAGS += -pedantic

ifndef SOURCES
# The homogeneous sources have mass action solvers that can be pre-compiled.
SOURCES = $(wildcard Homogeneous*.cc)
endif
DEPENDENCIES = $(SOURCES:.cc=.d)
TARGETS = $(SOURCES:.cc=)

.SUFFIXES:
.SUFFIXES: .cc .d

# The default target.
install: all
	mv $(TARGETS) ../../solvers

all: $(TARGETS)

clean: 
	$(RM) *.o *.d *~ core* *.stackdump .DS_Store .Thumbs.db

distclean: 
	$(MAKE) clean 
	$(RM) $(TARGETS) $(DEPENDENCIES)

again: 
	$(MAKE) distclean 
	$(MAKE) 

# Implicit rules.

.cc.d: 
	$(CXX) -MM $(CXXINCLUDE) $< > $@.$$$$; \
  sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
  $(RM) $@.$$$$

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include $(DEPENDENCIES)
endif
endif

=== debian/changelog ===
cain (1.9-7) unstable; urgency=low

  * Replace libeigen2-dev by libeigen3-dev.  (Thanks for the patch to
    Anton Gladky <gladk@debian.org>)
    Closes: #726200
  * debian/control:
     - cme fix dpkg-control
     - Priority: optional

 -- Andreas Tille <tille@debian.org>  Mon, 14 Oct 2013 21:35:53 +0200

cain (1.9-6) unstable; urgency=low

  * Enable arch only builds (thanks for the patch to Adam Conrad
    <adconrad@debian.org>)
    Closes: #685066

 -- Andreas Tille <tille@debian.org>  Thu, 16 Aug 2012 12:54:18 +0200

cain (1.9-5) unstable; urgency=low

  [ Ivo Maintz ]
  * debian/rules: remove lots of superfluos files in help/ and gui/
  * fixed broken links in the help
    LP: #1032304

  [ Andreas Tille ]
  * debian/control:
     - Build-Depends: zip
     - Removed quilt from Build-Depends
  * debian/rules: use xz compression

 -- Andreas Tille <tille@debian.org>  Fri, 10 Aug 2012 14:09:53 +0200

cain (1.9-4) unstable; urgency=low

  * debian/rules: Enable binary only builds
    Closes: #674235

 -- Andreas Tille <tille@debian.org>  Thu, 24 May 2012 09:48:53 +0200

cain (1.9-3) unstable; urgency=low

  [ Ivo Maintz ]
  * added a simple manpage

  [ Andreas Tille ]
  * debian/upstream: Add publication information
  * debian/patches/gcc-4.7.patch: Fix build failure with GCC 4.7.
    (Thanks for the patch to Matthias Klose <doko@debian.org>)
    Closes: #672045
  * debian/patches/*: DEP3 descriptions for patches
  * debian/control: Standards-Version: 3.9.3 (no changes needed)
  * debhelper 9 (control+compat)
  * debian/{dirs,docs}: deleted because unused
  * debian/patches/hardening.patch: Propagate hardening flags
  * debian/rules: Rewritten to use short dh which finally cares for
    the propagation of hardening flags (when doing so use installation
    via direct debhelper control files: *.install)
  * debian/cain-solvers.{install,links}: install solvers into
    usr/lib/cain/solvers rather than usr/lib/solvers
  * debian/menu: Use existing menu section

 -- Andreas Tille <tille@debian.org>  Tue, 22 May 2012 07:59:45 +0200

cain (1.9-2) unstable; urgency=low

  * changed the partitioning of the package

 -- Ivo Maintz <ivo@maintz.de>  Thu, 13 Oct 2011 13:12:12 +0200

cain (1.9-1) unstable; urgency=low

  * New upstream release

 -- Ivo Maintz <ivo@maintz.de>  Wed, 28 Sep 2011 12:02:11 +0200

cain (1.8-1) natty; urgency=low

  * update from upstream

 -- Ivo Maintz <ivo@maintz.de>  Fri, 23 Sep 2011 14:18:03 +0200

cain (1.6-3) natty; urgency=low

  * now the solvers are build, too

 -- Ivo Maintz <ivo@maintz.de>  Wed, 22 Jun 2011 13:01:39 +0200

cain (1.6-2) natty; urgency=low

  * recompiled for natty

 -- Ivo Maintz <ivo@maintz.de>  Thu, 05 May 2011 10:09:41 +0200

cain (1.6-1) unstable; urgency=low

  * Update from Upstream

 -- Ivo Maintz <ivo@maintz.de>  Mon, 07 Feb 2011 12:18:23 +0100

cain (1.5-1) unstable; urgency=low

  * Initial release

 -- Ivo Maintz <ivo@maintz.de>  Tue, 05 Oct 2010 14:31:33 +0200

=== debian/control ===
Source: cain
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ivo Maintz <ivo@maintz.de>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               python-all-dev,
               python (<< 3.0),
               libeigen3-dev,
               zip
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/cain/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/cain/trunk/
Homepage: http://cain.sourceforge.net

Package: cain
Architecture: all
Depends: ${python:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         python (<< 3.0),
         python-wxgtk2.8,
         python-matplotlib,
         python-numpy,
         python-scipy,
         python-sympy,
         cain-solvers
Recommends: cain-examples
Description: simulations of chemical reactions
 Cain performs stochastic and deterministic simulations of chemical reactions.
 It can spawn multiple simulation processes to utilize multi-core computers.
 It stores models, methods, and simulation output (populations and reaction
 counts) in an XML format. In addition, SBML models can be imported and
 exported. The models and methods can be read from input files or edited
 within the program.
 .
 The GUI (Graphical User Interface) is written in Python and uses the wxPython
 toolkit. Most of the solvers are implemented as command line executables,
 written in C++, which are driven by Cain. This makes it easy to launch batch
 jobs. It also simplifies the process of adding new solvers. Cain offers a
 variety of solvers:
  * Gillespie's direct method.
  * Gillespie's first reaction method.
  * Gibson and Bruck's next reaction method.
  * Tau-leaping.
  * Hybrid direct/tau-leaping.
  * ODE integration.
 .
 This package provides the architecture independent files for cain

Package: cain-solvers
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libeigen3-dev
Description: simulations of chemical reactions
 Cain performs stochastic and deterministic simulations of chemical reactions.
 It can spawn multiple simulation processes to utilize multi-core computers.
 It stores models, methods, and simulation output (populations and reaction
 counts) in an XML format. In addition, SBML models can be imported and
 exported. The models and methods can be read from input files or edited
 within the program.
 .
 The GUI (Graphical User Interface) is written in Python and uses the wxPython
 toolkit. Most of the solvers are implemented as command line executables,
 written in C++, which are driven by Cain. This makes it easy to launch batch
 jobs. It also simplifies the process of adding new solvers. Cain offers a
 variety of solvers:
  * Gillespie's direct method.
  * Gillespie's first reaction method.
  * Gibson and Bruck's next reaction method.
  * Tau-leaping.
  * Hybrid direct/tau-leaping.
  * ODE integration.
 .
 This package provides the solver libraries

Package: cain-examples
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cain
Description: simulations of chemical reactions
 Cain performs stochastic and deterministic simulations of chemical reactions.
 It can spawn multiple simulation processes to utilize multi-core computers.
 It stores models, methods, and simulation output (populations and reaction
 counts) in an XML format. In addition, SBML models can be imported and
 exported. The models and methods can be read from input files or edited
 within the program.
 .
 The GUI (Graphical User Interface) is written in Python and uses the wxPython
 toolkit. Most of the solvers are implemented as command line executables,
 written in C++, which are driven by Cain. This makes it easy to launch batch
 jobs. It also simplifies the process of adding new solvers. Cain offers a
 variety of solvers:
  * Gillespie's direct method.
  * Gillespie's first reaction method.
  * Gibson and Bruck's next reaction method.
  * Tau-leaping.
  * Hybrid direct/tau-leaping.
  * ODE integration.
 .
 This package provides the cain examples

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SRC_TMP=$(CURDIR)/SRC_TMP
debtmp := $(CURDIR)/debian/tmp

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
VERSION := $(shell dpkg-parsechangelog | grep Version | cut -d\  -f2 | cut -d- -f1)
UVERSION := $(shell dpkg-parsechangelog | grep Version | cut -d\  -f2 | cut -d- -f1 | sed 's/\./_/g')

%:
	dh $@ --with python2

override_dh_install-indep:
	dh_install
	rm -rf debian/$(pkg)/usr/share/cain/help/* debian/$(pkg)/usr/share/cain/gui/help.htm*
	cd help && zip ../debian/$(pkg)/usr/share/cain/help/cain.htb * -r -q -x *.htb *.htd
	if [ -d debian/$(pkg)/usr/share/cain/ ] ; then \
	    find debian/$(pkg)/usr/share/cain/ -type f -executable -exec chmod 644 {} + ; \
	fi

override_dh_auto_test:
	echo "no tests implemented"

override_dh_builddeb:
	dh_builddeb -- -Z xz

get-orig-source:
	rm -rf $(SRC_TMP) && mkdir $(SRC_TMP)
	#[ -f ../cain_$(VERSION).zip ] || wget -O ../cain_$(VERSION).zip http://sf.net/cain/Cain-$(UVERSION).zip # URL did not work
	[ -f ../cain_$(VERSION).zip ] ||  wget -O ../cain_$(VERSION).zip http://qa.debian.org/watch/sf.php/cain/Cain-$(UVERSION).zip
	cd $(SRC_TMP) && unzip ../../cain_$(VERSION).zip
	mv $(SRC_TMP)/Cain $(SRC_TMP)/cain-$(VERSION)
	find $(SRC_TMP) -name __MACOSX -type d | xargs -r rm -rf
	find $(SRC_TMP) -iname .DS_Store -exec rm -f {} +
	find $(SRC_TMP) -iname .scons* -exec rm -f {} +
	rm -f $(SRC_TMP)/cain-$(VERSION)/solvers/*
	rm -rf $(SRC_TMP)/cain-$(VERSION)/src/third-party/*
	cd $(SRC_TMP) && tar cvzf ../../cain_$(VERSION).orig.tar.gz cain-$(VERSION)
	rm -rf $(SRC_TMP)

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./" \
http://sf.net/cain/[cC]ain-(\d_\d).zip

## cain 1.10%2Bdfsg

=== debian/changelog ===
cain (1.10+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix build by making sure directory exists.
  * Make build reproducible.
    - Use stable order for files in help HTB.
    - Use consistent timezone.
    - Use consistent file permissions.
  * d/README.Debian: drop duplicate word
  * Use secure Vcs-Git.
  * Remove menu file to comply with new standards.
  * Enable full hardening.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Fri, 27 May 2016 10:15:44 +0000

cain (1.10+dfsg-1) unstable; urgency=medium

  [ Ivo Maintz ]
  * debian/rules:
    - added patch by Chris Lamb <lamby@debian.org> for
      repoducible builds
      Closes: #792684
  * debian/control:
    - bumped Standards-Version to 3.9.6
    - changed description for cain-examples and cain-solvers

  [ Andreas Tille ]
  * New upstream version
  * Fixed watch file
  * debian/copyright rewritten to match DEP5
  * Moved packaging from SVN to Git
  * Remove debian/menu

 -- Andreas Tille <tille@debian.org>  Sat, 19 Dec 2015 07:22:11 +0100

cain (1.9-8) unstable; urgency=medium

  * Moved debian/upstream to debian/upstream/metadata
  * cme fix dpkg-control
  * Depends: python-wxgtk3.0 (instead of python-wxgtk2.8)
    Closes: #759051

 -- Andreas Tille <tille@debian.org>  Mon, 25 Aug 2014 09:18:36 +0200

## cain 1.10+dfsg

=== Makefile ===
--- 
+++ 
@@ -17,6 +17,8 @@
 	rm -rf Cain.app/Contents/Resources/simulation
 	rm -rf Cain.app/Contents/Resources/solvers
 	rm -rf Cain.app/Contents/Resources/state
+	rm -f solvers/*
+	rm -f src/solvers/*.d
 
 test:
 	nosetests --with-doctest -v simulation state

=== src/solvers/Makefile ===
--- 
+++ 
@@ -20,6 +20,10 @@
 CXXFLAGS += -ansi -Wall
 # Commented out for Eigen.
 #CXXFLAGS += -pedantic
+
+ifeq ($(shell uname),Linux)
+  LOADLIBES += -lrt
+endif
 
 ifndef SOURCES
 # The homogeneous sources have mass action solvers that can be pre-compiled.

=== src/solvers/SConstruct ===
# -*- python -*-

import os.path
from env import serial

build = '../../solvers'
VariantDir(build, '.', duplicate=0)

if COMMAND_LINE_TARGETS:
    sources = [x + '.cc' for x in COMMAND_LINE_TARGETS]
else:
    sources = Glob('Homogeneous*.cc')

for source in sources:
    serial.Program(os.path.join(build, str(source)))

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
                python (<< 3.0),
                libeigen3-dev,
                zip
-Standards-Version: 3.9.4
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/cain/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/cain/trunk/
+Standards-Version: 3.9.6
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/cain.git
+Vcs-Git: git://anonscm.debian.org/debian-med/cain.git
 Homepage: http://cain.sourceforge.net
 
 Package: cain
@@ -20,7 +20,7 @@
          ${shlibs:Depends},
          ${misc:Depends},
          python (<< 3.0),
-         python-wxgtk2.8,
+         python-wxgtk3.0,
          python-matplotlib,
          python-numpy,
          python-scipy,
@@ -54,7 +54,7 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          libeigen3-dev
-Description: simulations of chemical reactions
+Description: solvers for cain
  Cain performs stochastic and deterministic simulations of chemical reactions.
  It can spawn multiple simulation processes to utilize multi-core computers.
  It stores models, methods, and simulation output (populations and reaction
@@ -81,7 +81,7 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          cain
-Description: simulations of chemical reactions
+Description: examples for cain
  Cain performs stochastic and deterministic simulations of chemical reactions.
  It can spawn multiple simulation processes to utilize multi-core computers.
  It stores models, methods, and simulation output (populations and reaction

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SRC_TMP=$(CURDIR)/SRC_TMP
debtmp := $(CURDIR)/debian/tmp

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
VERSION := $(shell dpkg-parsechangelog | grep Version | cut -d\  -f2 | cut -d- -f1)
UVERSION := $(shell dpkg-parsechangelog | grep Version | cut -d\  -f2 | cut -d- -f1 | sed 's/\./_/g')

%:
	dh $@ --with python2

override_dh_auto_clean:
	dh_auto_clean
	rm -rf solvers

override_dh_auto_build:
	mkdir solvers
	dh_auto_build

override_dh_install-indep:
	dh_install
	rm -rf debian/$(pkg)/usr/share/cain/help/* debian/$(pkg)/usr/share/cain/gui/help.htm*
	cd help && zip ../debian/$(pkg)/usr/share/cain/help/cain.htb * -r -q -x *.htb *.htd
	if [ -d debian/$(pkg)/usr/share/cain/ ] ; then \
	    find debian/$(pkg)/usr/share/cain/ -type f -executable -exec chmod 644 {} + ; \
	fi

override_dh_auto_test:
	echo "no tests implemented"

get-orig-source:
	uscan --verbose --force-download --repack --compression xz
#	find $(SRC_TMP) -type f -exec chmod 644 {} +
#	find $(SRC_TMP) -type d -exec chmod 755 {} +

=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,uversionmangle=s/_/./" \
  http://sf.net/cain/[cC]ain-(\d[\d\._]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz))|zip)
